
is_a = isinstance

import Parsing

T = Parsing.Token
NT = Parsing.Nonterm

class t_caret (T):
    "%token caret [p1]"

class t_slashslash (T):
    "%token slashslash [p1]"

class t_rshift (T):
    "%token rshift [p1]"

class t_slash (T):
    "%token slash [p1]"

class t_percent (T):
    "%token percent [p1]"

class t_NUMBER (T):
    "%token NUMBER [p1]"

class t_splat (T):
    "%token splat [p1]"

class t_STRING (T):
    "%token STRING [p1]"

class t_plus (T):
    "%token plus [p1]"

class t_vbar (T):
    "%token vbar [p1]"

class t_lshift (T):
    "%token lshift [p1]"

class t_tilde (T):
    "%token tilde [p1]"

class t_ampersand (T):
    "%token ampersand [p1]"

class t_splatsplat (T):
    "%token splatsplat [p1]"

class t_minus (T):
    "%token minus [p1]"

class t_NAME (T):
    "%token NAME [p1]"

class p1 (Parsing.Precedence):
    "%right p1"
class expr_2 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce expr_2 vbar factor_44 term_35 arith_expr_24 shift_expr_17 and_expr_10 xor_expr_6 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class expr (NT):
    "%start"
    def r_0 (self, *args):
        "%reduce factor_44 term_35 arith_expr_24 shift_expr_17 and_expr_10 xor_expr_6 expr_2 [p1]"
class xor_expr_6 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce xor_expr_6 caret factor_44 term_35 arith_expr_24 shift_expr_17 and_expr_10 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class and_expr_10 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce and_expr_10 ampersand factor_44 term_35 arith_expr_24 shift_expr_17 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class shift_expr_14 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce lshift [p1]"
    def r_1 (self, *args):
        "%reduce rshift [p1]"
class shift_expr_17 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce shift_expr_17 shift_expr_14 factor_44 term_35 arith_expr_24 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class arith_expr_21 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce plus [p1]"
    def r_1 (self, *args):
        "%reduce minus [p1]"
class arith_expr_24 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce arith_expr_24 arith_expr_21 factor_44 term_35 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class term_28 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce splat [p1]"
    def r_1 (self, *args):
        "%reduce slash [p1]"
class term_30 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce term_28 [p1]"
    def r_1 (self, *args):
        "%reduce percent [p1]"
class term_32 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce term_30 [p1]"
    def r_1 (self, *args):
        "%reduce slashslash [p1]"
class term_35 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce term_35 term_32 factor_44 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class factor_39 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce plus [p1]"
    def r_1 (self, *args):
        "%reduce minus [p1]"
class factor_41 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce factor_39 [p1]"
    def r_1 (self, *args):
        "%reduce tilde [p1]"
class factor_44 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce factor_41 factor_44 [p1]"
    def r_1 (self, *args):
        "%reduce atom_54 power_46 [p1]"
class power_46 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce splatsplat factor_44 [p1]"
    def r_1 (self, *args):
        "%reduce  [p1]"
class atom_50 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce NAME [p1]"
    def r_1 (self, *args):
        "%reduce NUMBER [p1]"
class atom_52 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce atom_52 STRING [p1]"
    def r_1 (self, *args):
        "%reduce STRING [p1]"
class atom_54 (NT):
    "%nonterm"
    def r_0 (self, *args):
        "%reduce atom_50 [p1]"
    def r_1 (self, *args):
        "%reduce atom_52 [p1]"

from pdb import set_trace as trace
from pprint import pprint as pp

def make_map (l):
    m = {}
    for i in range (len (l)):
        m[l[i]] = i
    return m

def build_tables (s):
    tokens   = s._tokens.keys()
    nonterms = s._nonterms.keys()
    goto     = s._goto
    action   = s._action
    token_map = make_map (tokens)
    nt_map = make_map (nonterms)
    action2 = []
    for i in range (len (action)):
        d = {}
        for k,v in action[i].iteritems():
            # v is always a one-element list?  GLR-related?
            if is_a (v[0], Parsing.ShiftAction):
                v = -1, v[0].nextState
            elif is_a (v[0], Parsing.ReduceAction):
                p = v[0].production
                v = -2, (len(p.rhs), p.lhs.name)
            else:
                raise ValueError
            d[token_map[k.name]] = v
        action2.append (d)
    goto2 = []
    for i in range (len (goto)):
        d = {}
        for k,v in goto[i].iteritems():
            d[k.name] = v
        goto2.append (d)
    return goto2, action2, token_map, nt_map

def get_state (stack):
    if stack:
        return stack[-1][1]
    else:
        return 0

def machine (goto, action, tmap, ntmap, stream):
    stack = []
    while len(stream):
        kind, val = stream[0]
        state = get_state (stack)
        print '-----  stack=', stack
        print '*****     kind,val=',kind,val
        print '********* state=',state
        shift_reduce, n = action[state][tmap[kind]]
        if shift_reduce is -1:
            # shift
            stream.pop (0)
            stack.append ((val, n))
        elif shift_reduce is -2:
            # reduce
            plen, nt = n
            print '-------   plen,nt=', plen, nt
            if plen == 0:
                args = []
            else:
                stack, args = stack[:-plen], stack[-plen:]
            next_state = goto[get_state(stack)][nt]
            stack.append (((nt,[x[0] for x in args]), next_state))
    if stack[-1][0] == '<$>':
        return stack[0][0]
    else:
        raise SyntaxError

import sys

stream = [
    ('NAME','x'),
    ('plus','+'),
    ('NAME','y'),
    ('slash','/'),
    ('NAME','z'),
    ('splatsplat','**'),
    ('NUMBER','3'),
    ('<$>','<$>')
    ]

class Parser (Parsing.Lr):

    def scan (self, input):
        for ttype, tdata in input:
            tok = eval ('t_%s' % (ttype,)) (self)
	    self.token (tok)
	self.eoi()

spec = Parsing.Spec (sys.modules[__name__], skinny=False, logFile="t0.log", verbose=True)

#p = Parser (spec)
#p._verbose = True
#p.scan (stream)

goto, action, tmap, ntmap = build_tables (spec)
pp (machine (goto, action, tmap, ntmap, stream))
